$(function(){
  init();
});

let MasterNode = "-";

let appData = {
  master: "-",
  slaves: [],
  slaves_selected: []
}

function init(){

  // css
  $("#nodelist").css({
    padding:'10px 0px'
  });

  $("#masternode").css({
    'font-weight': 'bold'
  });

  update_master_node();

  // init button
  $('#testbutton').on('click', function(e){

    $.ajax({
      url: '/api/nodelist',
      success: function(response){

        const l = response.trim().split('\n');

        let ll = [];

        $("#nodelist").empty();
        l.forEach(function(entry) {
          ll.push("<div class='master_nodes'>"+entry+"</div>");
        });
        $("#nodelist").empty().append(ll.join('\n'));

        $(".master_nodes").on('click',function(e){
          update_master_node($(this).html());
          $("#nodelist").empty();
          //send_command(appData.slaves,'list', parse_cmd_list_init);
          // go straight with ifconfig
          send_command(appData.slaves,'ifconfig', parse_cmd_ifconfig_init);
        });

      }
    });

  });

  $('#testbutton1').on('click', function(e){
    send_command(appData.slaves_selected,'list', parse_cmd_list);
  });

  $('#testbutton2').on('click', function(e){
    send_command(appData.slaves_selected,'state', parse_cmd_state);
  });

  // need a post request
  $('#testbutton3').on('click', function(e){

    //let cmd = "wget -qO- -o /dev/null 'http://localhost/parsedit.php?immediate&amp;TRIG'";
    //let cmd = "ifconfig";
    //let cmd = "wget -qO- -o /dev/null 'http://localhost/diagnostics.php'";
    const cmd = "ifconfig";
    send_command(appData.slaves_selected, cmd, parse_cmd_ifconfig);

  });

}

function parse_cmd_list_init(res){

  $(res).find('target').each(function(){
    const name = $(this).text();
    update_slave_list(name);
  });

  $(".slave_checkbox").on("change",function(e){
    let checked = $(this).prop("checked");
    let name = $(this).parent().find("label").html();
    console.log(checked+" "+name);
    if (!checked) {
      appData.slaves_selected = appData.slaves_selected.filter(item => item!==name);
    }else{
      appData.slaves_selected.push(name);
    }
  });

}

function parse_cmd_list(res){

  let rtab = [
    '<table class="slave_table">',
    '  <tr>',
    '  <th>Slave</th>',
    '  </tr>'
  ];

  $(res).find('target').each(function(){
    const name = $(this).text();
    //update_slave_list(name);
    rtab = rtab.concat([
      '<tr>',
      '  <td class="name">'+name+'</td>',
      '</tr>',
    ]);
  });
  rtab.push('</table>');
  $("#nodelist").empty().append(rtab.join('\n'));

}

function parse_cmd_state(res){

  let rtab = [
    '<table class="slave_table">',
    '  <tr>',
    '  <th>Slave</th>',
    '  <th>State</th>',
    '  </tr>'
  ];

  $(res).find('response').each(function(){
    const name = $(this).find('node').text();
    const state = $(this).find('state').text();
    rtab = rtab.concat([
      '<tr>',
      '  <td class="name">'+name+'</td>',
      '  <td class="state">'+state+'</td>',
      '</tr>',
    ]);
  });
  rtab.push('</table>');
  $("#nodelist").empty().append(rtab.join('\n'));
}

function parse_cmd_testing(res){

  $(res).find('response').each(function(){
    const name = $(this).find('node').text();
    const state = $(this).find('state').text();
    console.log(state);
  });

}

function parse_cmd_ifconfig(res){

  $(res).find('response').each(function(){
    const name = $(this).find('node').text();
    const state = $(this).find('state').text();
    const ip = get_ipaddr_from_ifconfig(state);
    console.log(ip);
    $("."+name+" label").html(name+" ("+ip+")");
  });

}

function send_command(targets, cmd, callback){

    let targets_str = "";
    if (Array.isArray(targets)){
      targets_str = targets.join(',');
    }else if (typeof targets === 'string' || targets instanceof String){
      targets_str = targets;
    }else{
      targets_str = "";
    }

    $.ajax({
      type: "POST",
      url: '/api/cmd',
      data: {
          master:  appData.master,
          targets: targets_str,
          cmd:     cmd
      },
      dataType: "xml",
      success: callback
    });

}

function update_slave_list(name){
  appData.slaves.push(name);
  appData.slaves_selected.push(name);
  let html = [
    '<div class=\''+name+'\'>',
    '<input class=\'slave_checkbox\' type=\'checkbox\' checked />',
    '<label>'+name+'</label>',
    '</div>'
  ].join('\n');

  $("#slavenodes").append(html);

}

function update_master_node(newvalue){

  if (newvalue!==undefined){
    appData.master = newvalue;
    appData.slaves = [];
  }

  $("#masternode").html(appData.master);

}

function get_ipaddr_from_ifconfig(str){

  // for Elphel 10393
  const iface_regex_10393  = /[^\ \n]+(?=\ +Link\ encap)/gi;
  const ipaddr_regex_10393 = /(?<=inet\ addr\:)\d+\.\d+\.\d+\.\d+/gi;
  // for PC
  const iface_regex_pc     = /[^\ \n]+(?=\:\ flags)/gi;
  const ipaddr_regex_pc    = /(?<=inet\ )\d+\.\d+\.\d+\.\d+/gi;

  let res = "";

  let ifaces  = str.match(iface_regex_10393);
  let ipaddrs = str.match(ipaddr_regex_10393);

  if (ifaces===null || ipaddrs===null){
    ifaces  = str.match(iface_regex_pc);
    ipaddrs = str.match(ipaddr_regex_pc);
  }

  for(var i=0;i<ipaddrs.length;i++){
    if (ifaces[i]!=='lo') {
      res = ipaddrs[i];
    }
    break;
  }

  return res;

}







